<?php 

/**
 * Implementation of the hook_ff_ubiquity()
 * @see hook_ff_ubiquity()
 * @return unknown_type
 */
function node_ff_ubiquity() {
  $commands = array();
  
  $types = node_get_types('names');
  foreach ($types as $type => $name) {
    $type_url_correct = strtolower(str_replace(' ', '-', $type));
    $node_noun[] = $type_url_correct;
  }
  
  $commands[] = "
var noun_node_type = new CmdUtils.NounType(\"Type\",[\"". implode('","', $node_noun) ."\"]);
";
  
  $commands[] = array(
    'name' => '%prefix%-create',//-'. strtolower(str_replace(' ', '-', $name)),
    'description' => t('Create a node on @site_name', array('@site_name' => variable_get('site_name', 'Drupal'))),
    'takes' => '"type":noun_node_type',
    'modifiers' => array(
      '"called":noun_arb_text',
      '"containing":noun_arb_text'
    ),
    'preview' => "function( pblock, type, mods ) {
  var msg = 'Create a \${typeText} called<h3>\${titleText}<h3><small>containing</small><br/>\"\${bodyText}\".';
  var subs = {
    typeText: type.text,
    titleText: mods['called'].text,
    bodyText: mods['containing'].text
  };
  CmdUtils.log(subs);
  pblock.innerHTML = CmdUtils.renderTemplate( msg, subs );
}",
    'execute' => "function(type, mods){
  var titleText = mods['called'].text;
  var bodyText = mods['containing'].text || CmdUtils.getSelection();
  var url = '%site-url%/%path-glue%node/add/'+type.text;
  url += '%query-glue%title='+encodeURIComponent(titleText);
  url += '&body='+encodeURIComponent(bodyText);
  url += '&ff-ubiquity';
  Utils.openUrlInBrowser(url);
}",
  );
  
  
  // it would be great to have the possibility to "discover" the nodes in a page
  // Note for later:
  // Utils.currentChromeWindow()
  // CmdUtils.savePassword(opts) 
  // CmdUtils.retrieveLogins(name) 
  
  
  $commands[] = "
/*
 * The following features are working on page like the standard frontpage 
 */
var noun_node_action = new CmdUtils.NounType('Action',['edit', 'delete', 'publish', 'promote', 'demote']);
var noun_node = {
  _name:'Title',
  
  suggest:function() {
    var suggestions = [];
    var doc =  Application.activeWindow.activeTab.document;
    // @todo improve the search of nodes with better selectors
    var nodes = jQuery('.node[id^=\"node-\"]', doc);
    jQuery.each(nodes, function(i){
      var nid = jQuery(this).attr('id');
      nid = nid.split('-')[1];
      var title = jQuery('h2', this).text();
      if (nid && title) {
        suggestions.push(CmdUtils.makeSugg(title, title, nid));
      }
    });
    return suggestions;
  }
};
";
  
  $commands[] = array(
    'name' => '%prefix%-node',
    'description' => t('Change a node on @site_name', array('@site_name' => variable_get('site_name', 'Drupal'))),
    'takes' => '"action":noun_node_action',
    'modifiers' => array(
      '"node":noun_node',
    ),
    'preview' => "function( pblock, action, mods ) {
  var msg = '\${actionText} \${nodeText} (\${nodeNid})';
  var subs = {actionText: action.text, nodeText: mods['node'].text, nodeNid: mods['node'].data};
  pblock.innerHTML = CmdUtils.renderTemplate( msg, subs );
}",
    'execute' => "function(action, mods){
  //CmdUtils.log([action, mods]);
  var nid = mods['node'].data;
  if (action.text == 'delete' || action.text == 'edit') {
    var url = '". url('node', array('absolute' => TRUE)) ."/'+nid+'/'+action.text;
    //url += '". (variable_get('clean_urls', 0) ? '&' : '?') ."ff-ubiquity=1';
    Utils.openUrlInBrowser(url);
  }
  else {
    alert('This action ('+action.text+') is not yet supported');
  }
}",
  );
  
  
  return $commands;
}

